//Zeitmessung
#include <LiquidCrystal.h>
const int start=9;                //Definition Startanschluss
const int ziel=10;                //Definition Stopanschluss
const int mittelstueck=8;         //Definition eigentlicher heisser Draht
const int lautsprecher=11;        // Lautsprecher
const int taster=12;              //Definition Taster Spielstart
unsigned long startzeit;         
unsigned long vergangenezeit;     
unsigned long intervall = 1000;   //1000 ms = 1 s 
int x;                            //Hilfsvariable                  
int buttonstate;     
int counter;                      //Fehlerzaehler
int sekunde;                      //Sekundenzaehler
int minit;                        //Minutenzaehler
int starttaster=0;     
int startring;                   
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
void setup()
{
  pinMode(9, INPUT);
  pinMode(10, INPUT);
  pinMode(8, INPUT);
  pinMode(12, INPUT);
  pinMode(11, OUTPUT);            //Lautsprecher 
  
sekunde = 0;                      //Sekundenzaehler = 0
minit = 0;                        //Minutenzaehler = 0
Serial.begin(9600); 
lcd.begin(20,2);                  // zweizeilige oder vierzeilige  LCD
lcd.print("    HEISSER DRAHT");
lcd.setCursor(0,2);
lcd.print("Taste druecken");
}

void anzeige()
// Anzeige der Zeit im LCD Display
{
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Zeit  :  ");
  //lcd.setCursor(10,0);
  lcd.print(minit);
  lcd.print(":");
  if (sekunde < 10 )
  {
   lcd.print("0");
  }
  lcd.print(sekunde);
  lcd.print(" min");
  lcd.setCursor(0,1);
  lcd.print("Fehler:");
  lcd.setCursor(14,0);
}

void beginn()
// Warten auf Druck des Start-Tasters
{
  do 
  {
    delay(50);
  starttaster=digitalRead(taster);
  }
  while (starttaster==HIGH);
 counter =0;                     // sicherheitshalber für erneuten start
 sekunde = 0;
 minit = 0; 
  }

  void abfrastart()
  // Hier wird abgefragt ob der Startring berührt wird
  {
   do
   {
   startring = digitalRead(start);
   }
    while (startring == HIGH);
    delay(500); 
    do
    {
    startring = digitalRead(start);  
    }
    while (startring == LOW);     
    delay(500);  
 // und losgelassen wird
       
    }
    
void fehler()
//Zaehlung der Fehler (Beruehrung heisser Draht)
{
  buttonstate = digitalRead(mittelstueck);
  if (buttonstate == HIGH)
  {
    x=0;
  }
  else
  {
    (buttonstate == LOW && x==1);
    counter++;
    tone(lautsprecher,1000);
    delay(50);
    noTone(lautsprecher);
    delay(250);
  }
  lcd.setCursor(9,2);
  lcd.print(counter);
}

void endschleife()
{
   do                            //Zeitmessung  und Fehlerzaehlung
  {
  vergangenezeit = millis();
  if (vergangenezeit - startzeit >= intervall)
{
  Serial.println(startzeit);
 anzeige();
 sekunde = sekunde + 1;        
  if (sekunde > 59)              // ist eine Minute um ?
  {
    minit = minit + 1;          // Minute erhoehen
    sekunde = 0;                // Sekunde auf Null
  }
 startzeit = millis();           
}
fehler();
}
while 
(buttonstate = digitalRead(ziel));
(ziel == LOW);
}

void speaker()
{
tone(lautsprecher,1000);            //1000 Hz
delay(1000);
noTone(lautsprecher);              // Ton aus
delay(1000);
}

void loop() 
{
  beginn();                           // Abfrage des Tasters fuer START
  lcd.clear();
  lcd.print("Spiel kann beginnen");
  lcd.setCursor(0,2);
  lcd.print ("Griffel an Start");

  abfrastart();                      // Abfrage des Griffels an Start
   lcd.clear();
   lcd.print("Zeitmessung ");
  //delay(1000);
  lcd.setCursor(0,2);
  lcd.print("hat begonnen");
  tone(lautsprecher,1000);
  delay(800);
  noTone(lautsprecher);
  delay(200);
  endschleife();                     // Zeit und Fehlerzaehlung
  speaker();
}


